Description

| encountered what seems to be some form of database or form state corruption, while creating multiple subtasks for a task on our
local Redmine instance (running SVN r3608).

Steps to reproduce:

1. Create a parent task

2. Open up more than one subtask creation form from the parent task's Subtask "add" link (that is, in separate browser windows /
tabs)

3. Fill in each subtask's Subject field, without submitting them

4. Submit each form (window/tab) in succession, without strictly waiting for the previous submission to complete

The above shouldn't cause any trouble or corruption, because each form submission should be logically independent, but this doesn't
seem to be the case, as can be seen in this example i created on demo.redmine.org:

e #28907: Test parent
o #28908: Test child 1
o #28910: Test child 2
o #28909: Test child 3

(The subtask creation forms were submitted in the above order (1, 2, 3), but as can be seen from the issue numbers, Test child 3
happens to have been created before Test child 2.)

The exact symptoms of the corruption seems to vary; in the above example, it can be observed that although #28910 and #28909
both have "28907" in their parent field, they display each other as their respective parents in their parent trees: in other words, their
parentage is displayed as #28907—#28909—#28910 and #28907—#28910—#28909, instead of #28907—#28910 and
#28907—#28909.

Other symptoms i've observed:

® |n the local case, one child ended up displaying all the other children as a sequence of nested parents (despite all the children
having their parent field set to the same root issue)

e The parent issue sometimes displays only some of the children (despite all their parent fields being set), or none

¢ Trying to update the affected issues result in server-side Internal errors, or in one case a "Parent task translation missing: en,
activerecord, errors, models, issue, attributes, parent_issue_id, not_a_valid_parent" error

| could only solve this so far by deleting and recreating all the affected issues, without form submission overlap. (Deleting the children
alone seems insufficient; subsequent recreation fails.)

(I don't know if this problem is specific to subtask creation, or affects all task creation; i'm not sure how to test the latter.)

Related issues:
Is duplicate of Redmine - Defect #6579: Tree hierachy being currupted on mult... Closed 2010-10-05

History

#1 - 2010-08-31 15:53 - Piet Delport

Based on other occurrences i've seen, this corruption may be due to race conditions in the underlying nested sets model?

#2 - 2010-08-31 15:56 - Piet Delport

That is, i've seen it not only with subtask creations, but with parent reassignments and other operations involving parent / child task relationship
https://www.redmine.org/projects/redmine/repository/svn/revisions/3608
http://demo.redmine.org/issues/28907
http://demo.redmine.org/issues/28908
http://demo.redmine.org/issues/28910
http://demo.redmine.org/issues/28909

changes.

Other concurrent operations don't seem to have any problems: only hierarchy changes seem to trigger the corruption, and the symptoms seem to be
consistent with nested set left/right boundaries going haywire.

#3 - 2011-05-03 01:14 - David Martinez Moreno

This is hitting me as well, Redmine 1.1.2.

#4 - 2012-04-25 23:05 - Bruno Medeiros
It's really the same as #6579

#5 - 2012-06-01 10:31 - Eugene Hutorny

Hit this issue with the following scenario:
Two users concurrently update two different issues and assign the same parent id to both of them.
Hierarchy of the parent task becomes broken and access to its children may cause process hanging or crashing.

#6 - 2014-02-25 03:28 - Toshi MARUYAMA
- Status changed from New to Closed

- Resolution set to Duplicate

Duplicate of #6579.
#6579 has more discussions.

#7 - 2014-02-25 03:28 - Toshi MARUYAMA

- Related to deleted (Defect #6579: Tree hierachy being currupted on multiple submissions of an issue)

#8 - 2014-02-25 03:28 - Toshi MARUYAMA

- Is duplicate of Defect #6579: Tree hierachy being currupted on multiple submissions of an issue added

#9 - 2014-02-25 03:29 - Toshi MARUYAMA

- Related to deleted (Defect #6309: missing "not_a_valid_parent" from all the locale files?)
